package net.dries007.holoInventory;

import net.dries007.holoInventory.server.ServerEventHandler;
import net.minecraft.command.CommandBase;
import net.minecraft.command.CommandException;
import net.minecraft.command.ICommandSender;
import net.minecraft.command.WrongUsageException;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.BlockPos;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.ChatStyle;
import net.minecraft.util.EnumChatFormatting;

import java.util.List;

public class HICommand extends CommandBase
{
    @Override
    public String func_71517_b()
    {
        return HoloInventory.MODID.toLowerCase();
    }

    @Override
    public String func_71518_a(ICommandSender sender)
    {
        if (isOP(sender)) return "Use on a SSP world to configure. You don't have permission to modify the server.";
        return "Use '/" + func_71517_b() + " help' for more info.";
    }

    @Override
    public boolean func_71519_b(ICommandSender sender)
    {
        return true;
    }

    @Override
    public void func_71515_b(ICommandSender sender, String[] args) throws CommandException
    {
        if (isOP(sender)) throw new CommandException(func_71518_a(sender));
        else if (args.length == 0 || args[0].equalsIgnoreCase("help") || args[0].equalsIgnoreCase("h") || args[0].equalsIgnoreCase("?"))  showHelp(sender);
        else if (args[0].equalsIgnoreCase("ban"))
        {
            ServerEventHandler.catchNext = ServerEventHandler.Type.BAN;
            sender.func_145747_a(new ChatComponentText("Right click a block.").func_150255_a(new ChatStyle().func_150238_a(EnumChatFormatting.AQUA)));
        }
        else if (args[0].equalsIgnoreCase("unban"))
        {
            if (args.length == 1)
            {
                ServerEventHandler.catchNext = ServerEventHandler.Type.UNBAN;
                sender.func_145747_a(new ChatComponentText("Right click a block.").func_150255_a(new ChatStyle().func_150238_a(EnumChatFormatting.AQUA)));
            }
            else
            {
                boolean wasBanned = Helper.banned.remove(args[1]);
                if (wasBanned)
                    sender.func_145747_a(new ChatComponentText("Unbanned " + args[1]).func_150255_a(new ChatStyle().func_150238_a(EnumChatFormatting.GREEN)));
                else
                    sender.func_145747_a(new ChatComponentText(args[1] + " is not banned.").func_150255_a(new ChatStyle().func_150238_a(EnumChatFormatting.RED)));
            }
        }
        else if (args[0].equalsIgnoreCase("list"))
        {
            sender.func_145747_a(new ChatComponentText(HoloInventory.MODID.concat(" banlist:")).func_150255_a(new ChatStyle().func_150238_a(EnumChatFormatting.AQUA)));
            for (String type : Helper.banned)
            {
                sender.func_145747_a(new ChatComponentText(type));
            }
        }
        else throw new WrongUsageException(func_71518_a(sender));
    }

    private void showHelp(ICommandSender sender)
    {
        sender.func_145747_a(new ChatComponentText(HoloInventory.MODID).func_150255_a(new ChatStyle().func_150238_a(EnumChatFormatting.AQUA)).func_150257_a(new ChatComponentText(" by Dries007").func_150255_a(new ChatStyle().func_150238_a(EnumChatFormatting.WHITE))));
        sender.func_145747_a(new ChatComponentText("This command depends on the context in which it is used."));
        sender.func_145747_a(new ChatComponentText("On a server (OP only) it can be used to (un)ban a block type, server wide."));
        sender.func_145747_a(new ChatComponentText("On a client (SSP) it can be used to (un)ban a block type, client side only."));
        sender.func_145747_a(new ChatComponentText("Syntax:").func_150255_a(new ChatStyle().func_150228_d(true)));
        sender.func_145747_a(new ChatComponentText("/" + func_71517_b() + " <ban>"));
        sender.func_145747_a(new ChatComponentText("        Ban the next block you right click."));
        sender.func_145747_a(new ChatComponentText("/" + func_71517_b() + " <unban> [name]"));
        sender.func_145747_a(new ChatComponentText("        Un ban the next block you right click, or specified via the name."));
        sender.func_145747_a(new ChatComponentText("/" + func_71517_b() + " <list>"));
        sender.func_145747_a(new ChatComponentText("        Print a list of banned block types on the current side."));
    }

    @Override
    public List<String> func_180525_a(ICommandSender sender, String[] args, BlockPos pos)
    {
        if (args.length == 1) return func_71530_a(args, "help", "ban", "unban", "list");
        if (args.length == 2 && args[0].equalsIgnoreCase("unban")) return func_175762_a(args, Helper.banned);
        return super.func_180525_a(sender, args, pos);
    }

    private boolean isOP(ICommandSender sender)
    {
        return sender instanceof EntityPlayer && !MinecraftServer.func_71276_C().func_71203_ab().func_152596_g(((EntityPlayer) sender).func_146103_bH());
    }
}
