package net.dries007.holoInventory.server;

import net.dries007.holoInventory.Helper;
import net.dries007.holoInventory.HoloInventory;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.ChatStyle;
import net.minecraft.util.EnumChatFormatting;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.common.eventhandler.EventPriority;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

public class ServerEventHandler
{
    public static final ServerEventHandler I = new ServerEventHandler();

    private ServerEventHandler()
    {

    }

    public static Type catchNext = Type.NONE;

    public enum Type
    {
        NONE, BAN, UNBAN
    }

    @SubscribeEvent(priority = EventPriority.HIGHEST)
    public void onRightClick(PlayerInteractEvent event)
    {
        if (event.action != PlayerInteractEvent.Action.RIGHT_CLICK_BLOCK) return;

        if (catchNext == Type.NONE) return;
        boolean ban = catchNext == Type.BAN;
        catchNext = Type.NONE;
        event.setCanceled(true);

        TileEntity te = event.world.func_175625_s(event.pos);

        if (te == null)
        {
            event.entityPlayer.func_146105_b(new ChatComponentText("That block does not have a TileEntity.").func_150255_a(new ChatStyle().func_150238_a(EnumChatFormatting.RED)));
            return;
        }

        if (ban)
        {
            if (Helper.banned.add(te.getClass().getCanonicalName()))
                event.entityPlayer.func_146105_b(new ChatComponentText("Banned " + te.getClass().getCanonicalName()).func_150255_a(new ChatStyle().func_150238_a(EnumChatFormatting.GREEN)));
            else
                event.entityPlayer.func_146105_b(new ChatComponentText(te.getClass().getCanonicalName() + " is already banned.").func_150255_a(new ChatStyle().func_150238_a(EnumChatFormatting.RED)));
        }
        else
        {
            boolean wasBanned = Helper.banned.remove(te.getClass().getCanonicalName());
            if (wasBanned)
                event.entityPlayer.func_146105_b(new ChatComponentText("Unbanned " + te.getClass().getCanonicalName()).func_150255_a(new ChatStyle().func_150238_a(EnumChatFormatting.GREEN)));
            else
                event.entityPlayer.func_146105_b(new ChatComponentText(te.getClass().getCanonicalName() + " is not banned. Perhaps it is banned on the " +
                        (FMLCommonHandler.instance().getSide().isClient() ? "server" : "client") + "?").func_150255_a(new ChatStyle().func_150238_a(EnumChatFormatting.RED)));
        }

        HoloInventory.getInstance().saveBanned();
    }
}
